(function( $ ){

	$.fn.callme = function( options ) {

		var thisPhone = this, dispatcher = $({}), callMeOptions = {}, call;
		var settings = {
			username : "",
			password : "",
			dialpad: true,
			//togglemic: true,
			slideopen: true,
			buttontext: "loading...",
			buttontextready: "Call me",
			numbertodial: ""
    	};

    	if(options) {
	    	//lowercase all options passed in
	    	$.each(options, function(k,v){
	    		callMeOptions[k.toLowerCase()] = v;
	    	});
    	}

    	return this.each(function(){

    		if ( options ) {
        		$.extend( settings, callMeOptions );
      		}

      		var phone = buildPhone( settings );

      		$(this).append(phone);

      		// event handlers
      		phone.find(".phono-digit").bind({
      			mouseenter: function(){
      				$(this).addClass("ui-state-hover");
      			},
      			mouseleave: function(){
      				$(this).removeClass("ui-state-hover");
      			},
      			mousedown: function(){
      				$(this).addClass("ui-state-active");
      			},
      			mouseup: function(){
      				$(this).removeClass("ui-state-active");
      			},
      			click: function(e){
      				//if( call )  Plivo.conn.call doesn't return call object so disabling this check for now
              dtmf($(this).attr("title"));
      				e.preventDefault();
      			}
      		});

      		dispatcher.bind({
      			// plivo client is ready, bind events to the call button
      			plivoReady: function(){
      				var btn = phone.find("a.phono-phone-button");
      				btn.bind({
      					click: function(e){
                          phoneBtn = phone.find(".phono-phone-button");
    		              if(phoneBtn.text() == "Hang Up") {
                            hangUpCall(settings, phone)
                          }
                          else {
                            makeCall(settings, phone);
                          }
      						e.preventDefault();
      					}
      				});

      				btn.text(settings.buttontextready);
      			}
      		});

			$(document).ready(function() {
		    Plivo.onWebrtcNotSupported = webrtcNotSupportedAlert;
        Plivo.onReady = onReady;
        //Plivo.onLogin = onLogin;
        Plivo.onLoginFailed = onLoginFailed;
        //Plivo.onLogout = onLogout;
        Plivo.onCalling = onCalling;
        Plivo.onCallRemoteRinging = onCallRemoteRinging;
        Plivo.onCallAnswered = onCallAnswered;
        Plivo.onCallTerminated = onCallTerminated;
        //Plivo.onIncomingCall = onIncomingCall;
        //Plivo.onIncomingCallCancelled = onIncomingCallCancelled;
        Plivo.init();
		    Plivo.conn.login(settings.username, settings.password);
      });
    	});

    	function buildPhone( settings ){
    		var phoneHldr = $( "<div/>")
    			.addClass("phono-hldr ui-widget ui-corner-all");

    		var phoneContent = $("<div/>")
    			.addClass("ui-widget-content ui-corner-all")
    			.css("padding","2px")
    			.appendTo(phoneHldr);

    		var statusLink = $("<a>")
    			.attr("href","#")
    			.addClass("phono-phone-button ui-widget-header ui-corner-all")
    			.css({
    				"text-align":"center",
    				"display":"block",
    				"padding":"8px 10px",
    				"text-decoration":"none"
    			})
    			.html(settings.buttontext)
    			.appendTo(phoneContent);

    		if( settings.dialpad ){
    			var digitTblHldr = $("<div/>")
    				.addClass("phono-digit-hldr")
    				.appendTo(phoneContent);

    			if(settings.slideopen)
    				digitTblHldr.css("display","none");

    			var digitTbl = $( "<table/>" )
    				.addClass( "phono-digits-tbl" )
    				.css({
    					"width": "100%"
    				})
    				.appendTo( digitTblHldr );

    			var digits = [
    				{key:"1", value:"&nbsp;"},
    				{key:"2", value:"ABC"},
    				{key:"3", value:"DEF"},
    				{key:"4", value:"GHI"},
    				{key:"5", value:"JKL"},
    				{key:"6", value:"MNO"},
    				{key:"7", value:"PQRS"},
    				{key:"8", value:"TUV"},
    				{key:"9", value:"WXYZ"},
    				{key:"*", value:"&nbsp;"},
    				{key:"0", value:"+"},
    				{key:"#", value:"&nbsp;"}
    			];

    			var tblRows = $("<tr><td></td><td></td><td></td></tr><tr><td></td><td></td><td></td></tr><tr><td></td><td></td><td></td></tr><tr><td></td><td></td><td></td></tr>")
    				.appendTo(digitTbl);

    			$.each(tblRows.find("td"), function( i, el ) {
    				var digitObj = digits[i];
    				$(el).css({
    						"padding":"1px",
    						"vertical-align":"top",
    						"width":"33%"
    					});

    				var digit = $( "<a/> ")
    				    .addClass( "phono-digit ui-state-default ui-corner-all" )
    				    .attr("title", digitObj.key)
    				    .attr("href","#")
    				    .css({
    				    	"padding":"3px",
    				    	"display":"block",
    				    	"text-align":"center",
    				    	"text-decoration":"none",
    				    	"font-size":"90%"
    				    })
    				    .html( digitObj.key )
    				    .appendTo( el );

    				var digitText = $("<span>")
    					.css({
    						"display":"block",
    						"font-size":"60%"
    					})
    					.html(digitObj.value)
    					.appendTo(digit);
    			});
    		}
    		return phoneHldr;
    	}



	function webrtcNotSupportedAlert() {
        $(".phono-hldr").html("Your browser doesn't support webrtc. You need Chrome 23 to use this phone.");
    }

	function onReady() {
        console.log("onReady...");
        dispatcher.trigger("plivoReady");
    }

	function onLoginFailed() {
        alert("Login Failed");
    }

	 function onCalling() {
        console.log("onCalling");
        $('#status_txt').text('Connecting....');
    }

    function onCallRemoteRinging() {
      ringbacktone.play();
      console.log("Ringing..");
    }

    function onCallAnswered() {
      ringbacktone.pause();
      console.log('onCallAnswered');
    }

    function onCallTerminated() {
      ringbacktone.pause();
        console.log("onCallTerminated");
    }

   function dtmf(digit) {
      console.log("send dtmf="+digit);
      Plivo.conn.send_dtmf(digit);
    }
  };
})( jQuery );

function formatUSNumber(n) {
  var dest = n.replace(/-/g, '');
  dest = dest.replace(/ /g, '');
  dest = dest.replace(/\+/g, '');
  dest = dest.replace(/\(/g, '');
  dest = dest.replace(/\)/g, '');
  if (!isNaN(dest)) {
    n = dest
    if (n.length == 10 && n.substr(0, 1) != "1") {
      n = "1" + n;
    }
  }
  return n;
}

function makeCall(settings, phone){
  phoneBtn = phone.find(".phono-phone-button");
  phoneBtn.text("Hang Up");

  if( settings.dialpad && settings.slideopen )
    phone.find(".phono-digit-hldr").slideDown();
  call = Plivo.conn.call(formatUSNumber(settings.numbertodial));
}

function hangUpCall(settings, phone){
  Plivo.conn.hangup();
  phone.find(".phono-phone-button").text(settings.buttontextready);

  if( settings.dialpad && settings.slideopen )
    phone.find(".phono-digit-hldr").slideUp();
}
